ClassFile.DeadLabelsOption (Java SE 25 & JDK 25)
Description: declaration: module: java.base, package: java.lang.classfile, interface: ClassFile, enum: DeadLabelsOption
Keywords: java.lang.classfile.ClassFile.DeadLabelsOption class

# Enum Class ClassFile.DeadLabelsOption

java.lang.Object
java.lang.Enum<ClassFile.DeadLabelsOption>
java.lang.classfile.ClassFile.DeadLabelsOption

All Implemented Interfaces:
  `Serializable, ClassFile.Option, Comparable<ClassFile.DeadLabelsOption>, Constable`

Enclosing interface:
  `ClassFile`

public static enum ClassFile.DeadLabelsOption extends Enum<ClassFile.DeadLabelsOption> implements ClassFile.Option
The option describing whether to filter unbound labels and drop their enclosing structures if possible. The default is `FAIL_ON_DEAD_LABELS` to fail fast with an `IllegalArgumentException` when a `PseudoInstruction` refers to an unbound label during bytecode generation.

The affected `PseudoInstruction`s include `ExceptionCatch`, `LocalVariable`, `LocalVariableType`, and `CharacterRange`. Setting this option to `DROP_DEAD_LABELS` filters these pseudo-instructions from a `CodeBuilder` instead. Note that instructions, such as `BranchInstruction`, with unbound labels always fail-fast with an `IllegalArgumentException`.

Since:
  24
See Also:
  - `ClassFile.DebugElementsOption`

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class Enum

  `Enum.EnumDesc<E>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `DROP_DEAD_LABELS`
  Filter `PseudoInstruction`s with unbound labels.
  `FAIL_ON_DEAD_LABELS`
  Fail fast on unbound labels.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static ClassFile.DeadLabelsOption`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static ClassFile.DeadLabelsOption[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods declared in class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods declared in class Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### FAIL_ON_DEAD_LABELS

    public static final ClassFile.DeadLabelsOption FAIL_ON_DEAD_LABELS
    Fail fast on unbound labels. This also ensures the accuracy of the generated `class` files.

  - ### DROP_DEAD_LABELS

    public static final ClassFile.DeadLabelsOption DROP_DEAD_LABELS
    Filter `PseudoInstruction`s with unbound labels. Note that instructions with unbound labels still cause an `IllegalArgumentException`.

- ## Method Details

  - ### values

    public static ClassFile.DeadLabelsOption[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static ClassFile.DeadLabelsOption valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null